/* PassMake version 1.2 created by Pawel Prokop - 01.03.2001 */

#include "pass.h"

void Usage (char * name)
{
printf("PassMake ver 1.3.1 by Pawel Prokop (prokopp@wizard.ae.krakow.pl)\n\n");
printf("Usage : %s -ludspq -L [length] -C [number] -S [seed] -W [string] -D [string]\n\n", name);
printf("\t-l\t\tlowercase characters\n\t-u\t\tuppercase characters\n\t-d\t\tdigits\n\t-s\t\t(!@#$...) like characters\n\t-p\t\tright-handed characters (placed on right side of keyboard)\n\t-q\t\tleft-handed characters (placed on left side of keyboard)\n\t-L\t\tlength 1-255, default=8\n\t-C\t\tnumber of passwords to generate, default=1\n\t-S\t\tuser specified random seed\n\t-W\t\tstring that'll be base string of password\n\t-D\t\tcharacters that are contained in password\n\n");
exit(0);
}

char Syn	(char c, char * pattern)
{
c=(char)tolower((int)c);
int i=0; 
char temp;
while ((*synon[i]!=c)&&(i<MAXSYN)) i++;
if (*synon[i]==c)	{
	temp=*(synon[i]+(int)((float)strlen(synon[i])*rand()/(RAND_MAX+1.0)));
	if (!strchr(pattern,(int)temp)) temp=*synon[i];
	return temp;
	}
else return c;
}

char * leftchar (char *pattern, unsigned int flags)
{
if (flags & LOWER)   strncat(pattern, llower, strlen(llower));
if (flags & UPPER)   strncat(pattern, lupper, strlen(lupper));
if (flags & DIGITS)  strncat(pattern, ldigit, strlen(ldigit));
if (flags & SPECJAL) strncat(pattern, lspcjl, strlen(lspcjl));
return (char*)NULL;
}

char * rightchar (char *pattern, unsigned int flags)
{
if (flags & LOWER)   strncat(pattern, rlower, strlen(rlower));
if (flags & UPPER)   strncat(pattern, rupper, strlen(rupper));
if (flags & DIGITS)   strncat(pattern, rdigit, strlen(rdigit));
if (flags & SPECJAL) strncat(pattern, rspcjl, strlen(rspcjl));
return (char*)NULL;
}


int main ( int argc, char * argv [] )
{
char * pattern = new char [strlen(llower)+strlen(lupper)+strlen(ldigit)+strlen(lspcjl)+strlen(rlower)+strlen(rupper)+strlen(rdigit)+strlen(rspcjl)];
*pattern=(char) NULL;
char word[MAXLEN+1];
*word=(char)NULL;
char declared[MAXLEN+1];
*declared=(char)NULL;
if (argc<2) Usage (argv[0]);
int i, p_size=DEFLEN, count=1, seed=0;
unsigned int flags=0;
while ((i=getopt(argc, argv, "ludsqpL:C:S:W:D:"))!=EOF)
	{
	switch(i)
		{
		case 'l': flags |= LOWER;//strncat(pattern, lower, strlen(lower));
			break;
		case 'u': flags |= UPPER;//strncat(pattern, upper, strlen(upper));
			break;
		case 'd': flags |= DIGITS;//strncat(pattern, digit, strlen(digit));
			break;
		case 's': flags |= SPECJAL;//strncat(pattern, spcjl, strlen(spcjl));
			break;
		case 'q': flags |= LEFT;
			break;
		case 'p': flags |= RIGHT;
			break;
		case 'L': p_size=atoi(optarg); // rozmiar generowanego hasla
			break;
		case 'C': count=atoi(optarg);  // liczba wygenerowanych hasel
			break;
		case 'S': seed=atoi(optarg);   // randseed
			break;
		case 'W': flags |= WORD;    // haslo generowane jako wariacja stringa
			strncpy(word,optarg,MAXLEN);
			break;
		case 'D': flags |= DECLARED;  // haslo generowane ze znakow podanych a stringu.
			strncpy(declared,optarg,MAXLEN);
			break;
		default :
			Usage (argv[0]);
			break;
		}
	}

if (!(flags & DECLARED))	{
	if (flags & WORD)	{
		leftchar(pattern, flags);
		rightchar(pattern, flags);
		}
	else {
		if (flags & LEFT)	leftchar(pattern,flags);
		if (flags & RIGHT) rightchar(pattern,flags);
		if (!(flags & RIGHT) && (!(flags & LEFT)))	{
	      leftchar(pattern, flags);
	      rightchar(pattern, flags);
			}
		}
	}	
else if ((flags & WORD)&&(flags & DECLARED))	{ // znaczy sie, ze kolesiowi sie cos pochrzanilo i nie wie co chce.
	printf("-D cannot be used with -W option. Use either -D or -W\n\n");
	exit(1);
	}
else {
	strncpy(pattern,declared,MAXLEN);
	}
	
if (count>MAXCOUNT)	{
	printf("Number of password to generate cannot be greater than %d\nSo using default value : 1\n\n",MAXCOUNT);
	count=1;
	}
if (!seed) srand(time((time_t)NULL));	
else srand(seed);

char output [MAXLEN+1];
int x, y=0,l; 
int w=strlen(word);
if (w>0)	{
	p_size=w;
	w=1;
	}

if ((l=strlen(pattern))==0) Usage(argv[0]);

// Tutaj fragment samemu losuje ciag znakow skladajacy sie na haslo.
while (y<count) {
	x=0;
	while (x<p_size) {
		if (w==0) *(output+x)=*(pattern+(int)((float)l*rand()/(RAND_MAX+1.0)));
		else *(output+x)=Syn(*(word+x), pattern);
		x++;
		}
	*(output+x)=(char)NULL;	
	printf("%s\n",output);	
	y++;
	}
return 0;
}

